#ifndef __norm_hash_h
#define __norm_hash_h

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>

#include <norm.h>
#include <norm_list.h>

#define NORM_HASHSIZE 64

typedef struct norm_hash NormHash;

typedef u_int (*NormHashFunc) (NormHash*, void *key);

struct norm_hash
{
  NormList     **slots;
  u_int         *slot_loads;

  NormHashFunc   hash_func;
  NormCmpFunc    cmp_func;
  NormFunc       free_func;

  u_int          num_items;
  u_int          num_slots;
  u_int          max_slot_load;
};

typedef struct norm_hash_item
{
  void *key;
  void *data;
}
NormHashItem;

NormHash     *norm_hash_new(NormHashFunc hash_func, NormCmpFunc cmp_func,
			    NormFunc free_func, int size, int max_chain_size);
void          norm_hash_free(NormHash* h);

void          norm_hash_insert(NormHash* h, void *key, void *data);
NormHashItem *norm_hash_find(NormHash *h, void *key);
void          norm_hash_remove(NormHash *h, void *key);

#endif

